#include <vector>
#include <set>
#include <string>
#include <map>

class Transceiver;

struct Tag
{
    std::string TagName;
    bool IsClosingTag;
    
    // name and value can both be empty
    std::vector<std::pair<std::string/*name*/, std::string/*value*/> > Params;
};
struct TagDef
{
    std::string MacroExpansion;
    std::vector<std::pair<std::string/*name*/, std::string/*defaultvalue*/> > AttrList;
    int Tag;
    std::string Flags; //?
    bool Is_OpenTag;  // Can user redefine this?
    bool Is_EmptyTag; // Does not require closing tag?
    
    void (Transceiver::*Handler) (const struct TagDef&, const struct Tag&);
    
    TagDef(): Tag(-1),Is_OpenTag(false),Is_EmptyTag(true) { }
};
struct EntityDef
{
    std::string Value;
    std::string Desc;
    bool Is_PubEnt;  // Can user query this?
    bool Is_OpenEnt; // Can user redefine this?
    bool Is_Recursive;
    
    EntityDef(): Is_PubEnt(false),Is_OpenEnt(false), Is_Recursive(false) { }
};

struct AttrMatchResult
{
    std::map<std::string, std::string> matched;
    std::vector<std::string> unmatched;
};
const AttrMatchResult DoAttrMatching(const TagDef& def, const Tag& tag);

const std::vector<std::pair<std::string/*name*/, std::string/*value*/> >
    ParseAttrList(const std::string& s, bool default_is_name);
